/*
#################################################
P1 Keine Angst vor sperrigen Ausdrücken 
###########################################
*/

/* bestimmt den den Drehwinkel der kürzesten Seite eines Rechtecks zur Nordrichtung */ 


to_int(
    with_variable('geo',    -- Eine der kurzen Seiten des Rechtecks wir als Variable @geo definiert

            with_variable( 'seg', segments_to_lines(boundary( oriented_bbox(  $geometry  )  )),   
                                                                    -- Innerhalb von @geo werden die EinzelLinienSegmente der
                                                                            -- Rechteckseiten als Variable @seg definiert
                                                                            
                case 
                    when  length(geometry_n( @seg,1)) <  length(geometry_n( @seg,2))  -- Bestimmung der kurzen Seite über den Längenvergleich der 
                                                                                    -- Seite 1 und der Seite 2 - Eine muss die kürzere sein!
                    
                    then geometry_n( @seg,1)                                        -- Wenn Seite 1 die kurze ist, dann Seite 1
                    
                    else geometry_n( @seg,2)                                        -- Ansonsten Seite 2
                    
                end
                    
            )
            ,    -- Ende der Definition von Variable @geo: Hinter diesem Kommas kann die Variable @geo verwendet werden
            -----------------------------------------------------
            -- Mit azimuth kann der Winkel einer graden zwischen zwei definierten Punkten, bezogenn auf Norden im Bogenmaß ermittelt werden
            -- Die Punkte sind Start- und Endpunkt der kurzen Seite des Rechtecks, welche die Variable @geo repräsentiert
        (
            case                                                            -- Der Winkel muss vom Norden gesehen gemessen werden.
                when  y(start_point(  @geo )) > y(end_point(  @geo  ))      -- Wenn der Startpunkt der kurzen Seite nördlich vom Endpunkt ist
                                                                            
                then  degrees(                                              -- dann soll der Winkel vom Start- zum Endpunkt gemessen werden
                                azimuth(                                   
                                            start_point(  @geo  ),          -- Der Winkel wird von azimuth in Bogenmaß bestimmt und mit
                                            end_point(    @geo )            -- degrees in Grad umgewandelt
                                        )
                            )
                
                
                else  degrees(                                              -- Ansonsten vom End- zum Startpunkt
                                azimuth( 
                                            end_point(   @geo  ), 
                                            start_point( @geo )
                                        )
                            )

            end
        )       - 180                      -- Von 180°  abziehen, damit der Ergebnis der Wirkung vom Vom QGIS-Drehwerkzeug entspricht)                                                     
    )                               -- diese Klammer schließt den Ausdruck, der mit der Definition der Variable @geo beginnt 
)

/* Neuerdings geht das aber auch einfach so: */
main_angle($geometry) + 90


/*
#################################################
Einfaches
###########################################
*/


/* Einfache Abfragen */

-- Direkter Vergleich
"GEN" = 'Stuttgart'
 
 -- Ähnlichkeit mit Platzhaltern: % steht für beliebige Anzal beliebiger Zeichen
 "GEN" like  'Rot%burg%'  -- findet z.B. Rothenburg oder Rottenberg
 
 -- Unterschiede like und ilike
"GEN" ilike  '%burg%' -- ilike berücksichtigt Groß- und Kleinschreibung
"GEN" like  '%burg%'  -- like ignoriert Groß- und Kleinsschrebung

-- Leerzeichen sind Zeichen
   "GEN" like 'Bad%'

   "GEN" like 'Bad% '
  
--Größenvergliech und between
 "EWZ"   >= 20000 and  "EWZ" <= 20000
  
"EWZ"  BETWEEN 20000 and 30000
 
 /*Zeichenketten-Funktionen  
 #################################*/
 --P2
-- Ersetzen Kaskade zum ändern von Umlauten

replace(replace(replace(  "GEN" ,'ö','oe'),'ü','ue') ,'ä','ae')

oder

replace(  
		replace(  
				replace(  "GEN" ,'ö','oe'),
				'ü','ue') 
,'ä','ae')




/* Mit substr("Spalte",Stelle,AnzahlStellen) lässst sich ein bereich einer Zeichenkett eextrahieren
Angebeben wird Stelle, ab welcher die Teilkette beginnt sowie die Anzahl der folgenden Stellen*/
 substr("SPALTE",starstelle, Länge)

 Beispielwert in "RS" '083355004002'
 
 substr("rs", 2, 4) ergibt '8335' 
 Über to_int() kann der Wert in eine Ganzzahl umgewandelt werden
 
 to_int(
        substr("rs", 2, 4) 
        )
8335
 
 left("RS",5) entspricht  substr("rs", 1, 5) 


 /*#######################################################################
GEOMETRIEWERTE EINBEZIEHEN In der Rubrik GEOMETRIE finden sich die Grundfunktionen zur Berechnung von Flächen, Strecken, Umfang und Koordinaten, nebst weiteren Funktionen. Ausgabeeinheit ist die Einheit des Koordinatenbezugssystems, bei ETRS89 / UTM32 und GK 3 ist dies der Meter. 
*/
  $area         Fläche 
  $length       Länge einer Strecke 
  $perimeter    Umfang einer Fläche 
  $x und $y     Koordinaten eines Punktes, des Geometriemittelpunktes
   
 -- Flächenberechnung mit drei Stellen hinterm Komma 
 round(            -- round(wert,Stellen) ist die Rundungsfunktion
	($area / 10000)   -- $area gibt die Fläche in Eiheiten des KBS aus (qm) geteilt durch 10000 ergibt ha
	,3)
  /*#######################################################################
GEOMETRIEWERTE EINBEZIEHEN In der Rubrik GEOMETRIE finden sich die Grundfunktionen zur Berechnung von Flächen, Strecken, Umfang und Koordinaten, nebst weiteren Funktionen. Ausgabeeinheit ist die Einheit des Koordinatenbezugssystems, bei ETRS89 / UTM32 und GK 3 ist dies der Meter. 
*/
 
 
 /*
#################################################
NULL-Werte und Verkettungen
###########################################
*/

 --###########################################################
 -- Beispiele für Verkettungeen von Werten zur Beschriftung.
 -- Verkettung mit dem Operator ||
 -- '\n' is ein Symbol für den Zeilenumbruch
 " Spaltenbezeichnungen"  ' Textwerte'
 
 "name"  || '\n ( ' || "EWZ"  || ' ) \n' ||  "anzahl" || ' Gem.'
 
 "name"  || '\n ( ' ||  format_number( "EWZ")  || ' ) \n' ||    "anzahl" || ' Gem.'

 Bei Verkettungen mit || als Operator wird der gesamte Ausdruck als NULL  gewertet, wenn ein Beteiligter Wert NULL ist.
 Alternativ ist die Funktion concat(,) zu verwenden, die NULL als leere Zeichenkette interpretiert.
 
 concat("name"  , ' ( ' , "EWZ"  , ' ) ' ,  "anzahl" ,' Gem.')
 
 coalesce("Ausdruck",0) ersetzt NULL durch 0
 coalesce("Ausdruck",'') ersetzt NULL durch '' also eine leere Zeichenkette

 
 --####################################################################
 --Bedingungen mit Case Hier Klassifikation Einwohnerzahl nach EWZ  
 --####################################################################
--P3
 Case
	when "EWZ" => 500000 then 'Riesig' 
	when  "EWZ" => 100000 then 'groß'
	when  "EWZ" => 50000 then 'mittel'
	when  "EWZ" => 15000 then 'klein'
	when  "EWZ" => 2000 then 'sehr klein'
	when "EWZ" < 2000 then 'winzig'
	
	Else 'unbekannt'
End
 --####################################################################
 --Bedingungen mit Case Hier Klassifikation Einwohnerzahl nach EWZ  
 --####################################################################
 
/*
#################################################
P4 Aggregieren
###########################################
*/
/* soll die kleinste oder größte Stadt Gefunden werden, helfen die Aggregatfunktionen  */

minimum( "EWZ") -- gibt die kleinste Einwonerzahl des Datenbestands aus und schreibt Sie in jede Zeile
maximum( "EWZ") -- gibt die größte Einwonerzahl des Datenbestands aus und schreibt Sie in jede Zeile

/* Es könne weitere Parameter angegeben werden, z.B zum gruppieren nach Werten einer weiteren Spalte 
In der Hilfe des AE werden die Parameter aufgeführt. Sie sind entweder in der richtigen Reihenfolge kommagetrennt zu notieren oder
als benannte Parameter in der Form parametername:= ausdruck einzugenen*/

minimum( "EWZ" , "BEZ")  -- Gibt die Namen der Gemeinde mit geringster EWZ, gruppiert nach  Spalte "BEZ" also jeweils für Stadt und Gemeinde aus
minimum( "EWZ" ,group_by:=  "BEZ")  --hier mit benanntem Paramter group:by

/* Die Verwendung benannter Parameter und Zeilenumbrüche machen komplexe Abfragen lesbarer
- Die Abfrage zur Ermittlung der Stadt mit der  der kleinsten Einwohnzahl in zwei verschiedenen Schreibweisen*/


-- In einer Zeile ohne benannte Parammeter
"EWZ" = minimum( "EWZ" ,"BEZ","BEZ" =  'Stadt' and "EWZ" > 0 )

-- Mit benannten Parametern
"EWZ" = minimum( "EWZ",group_by:= "BEZ", filter:=  "BEZ" = 'Stadt' and "EWZ" > 0 )

-- Mit Zeilenumbrüchen wird es lesbarer, ausserdem lassen sich Kommentare hinter die einzelnen Parameter schreiben
 
 "EWZ" =                    -- Der nachfolgende Ausdruck wird mit der EWZ jeder Zeile verglichen , wenn Übereinstimmung wird ausgewählt
    minimum( "EWZ" ,        -- Der minimale Wert des Einwohnerzahl im Datenestand
            group_by:=  "BEZ",      --Jeweils gruppiert nach Spalte BEZ, um jeweils für die Kategorie Stadt und der Kategorie Gemeinde zu ermitteln
            filter:=    "BEZ" =  'Stadt' and "EWZ" > 0  -- Ergebnis gefiltert auf Stadt und einer EWZ größer als 0
            )
		
-- Mit dem gleichen Verfahren ist auch die geringste oder höchste Einwohnerdichte von Städten mit weniger als 5000 Einwohner ermitteln
( "EWZ" / ( $area  / 1000000)) =
Maximum( ( "EWZ" / ( $area  / 1000000))  ,
		group_by:= "BEZ",
		filter:= "BEZ" =  'Stadt' and ("EWZ" > 0  and "EWZ" < 5000) 
		)


/*################################################
P5 Die 10 größten Städte suchen
###################################
*/


array_to_string(  		-- Rückumwandlung in Textfeld
	array_slice( 		-- Einzelne Stellen abfragen
		string_to_array(   -- umwandeln in Listenfeld (Array)
				
			concatenate(  "GEN",	--Auflistung aller gemeindenamen
						filter:=  "EWZ" > 0,
						order_by:= 1/"EWZ",  --sortiert absteigend
						concatenator:=','
						)
				)			--umgewandelt in Listenfeld 
				,0,9)		-- Stellen 0-9 werden abgefragt
		)					-- in text umgewandelt
	
	like 		-- Vergleich mit jeder Zeile. 
	'%' ||"gen"|| '%'  -- Entspricht ein  Teil der Liste der gemeinde

	-- Geht auch über 
    array_to_string(array_agg
            array_slice( 
                array_agg(  "GEN"  ,order_by:= 1 /"EWZ"),
                    0,9)
                    )
    like '%'||"gen" ||'%'

    /*################################################
Die 10 größten Städte suchen
###################################
*/  
    
--#################
--P6 Suchen und ersetzen mit regulären Ausdrücken
--#############


.*			 	= beliebige Anzahl beliebieger Zeichen
\\d++ 			= beliebige Anzahl Ziffern
\\/? 			=  Ein Schrägstrich oder auch nicht 
.\\d? 			= weitere Ziffern oder auch nicht
(dieses | jenes)= oder Bedingung
{1,2} =  		= ein oder zwei Vorkommen
+ 				=	 beliebig vielk Vorkommen
[] 				= Umschließt eine Gruppe von Zeichen z.B. [a-zA-Zßöäü] sämtliche Buchstaben, alternativ \\w+
$ 				= Suche die Zeichenkette vom Ende her. Steht am Ende der Eingabe

{} 
In geschweiften Klammern wird genannt, wie oft das voran- stehende Zeichen/Gruppe vorkommen muss, 
z. B. {2} = genau 2-mal, {2,4} = mindestens 2-, höchstens 4-mal, {2,} = mindes- tens 2-mal

* Der voranstehende Ausdruck darf beliebig oft (auch keinmal) vorkommen (entspricht {0,}) . Punkt; ein sog. Metazeichen. Es entspricht praktisch jedem Zeichen mit Ausnahme von Zeilenumbrüchen und kann daher gut als Platzhalter benutzt werden ^ Durchsuche die Zeichenkette von vorne (gilt für die in QGIS verwendete Regex-Spezifikation! Sonst steht ^ häufig für Negation des folgenden Ausdrucks!)

Beim Kraftwerks und beim WKS Layer finden sich Werte wieder
4.2 MW
4,2 MW
4.200 MW
4200 KW
3300 kW
100mW
2.0 MW
2 MW
19.25 KWp


Mal wird ein Komma mal ein Punkt verwendet. Die Werte in kw oder in MW angegeben, 
wobei Groß- unbd Kleinschreibung nicht konsequent ist.
Mal gibt es Leerzeichen und mal nicht....
Ziel ist es die Leistung als Dezimalzahl in Megawatt zu schreiben.

	case
		when  "leistung"  ilike '%kw%'  -- Testen ob kw in der Spalte vorkommz
		then
			
			regexp_substr(  replace(   "leistung"  ,',','.') ,'[0-9.]+') / 1000  -- Zahlenwerte und . herausholen sowie durch 1000 dividieren
		
		when   "leistung"  ilike '%mw%'
		then
			 regexp_substr(  replace(   "leistung"  ,',','.') ,'[0-9.]+') 
	end

/* Hausnummern extrahieren '*/

/*Wenn garantiert kein Leerzeichen in der Im Straßenname ist, lässt das Ganze auch mit substr und strpos lösen */

substr( 'Hauptstraße 32 ab',
							strpos('Hauptstraße 32 ab',' ') +1)
-- Der Ausdruck holt sämtliche Zeichen nach dem ersten Leerzeichen 

-- Das ist unflexibel. Mit regexp_substr ist es präziser
regexp_substr( 'Hauptstraße 32 ab' ,'\\d{1,4}[ a-z]{0,3}')       32 ab  -- 1-4 Ziffern dann aus der Menge Leerzeichen a-z 0-3 Zeichen
regexp_substr('Hauptstraße 32 ab','[0-9]{1,5}[ ]?[a-z]{0,2}')    32 ab  -- Aus der Menge 0-9 1-5 Zeichen, dann ein Leerzeichen oder nicht  dann aus der Menge a-z 0-2 Zeichen
regexp_substr(  'Hauptstraße 32 ab','\\d.{1,4}\\w{0,4}')         32 ab  -- 1-4 Ziffern ein beliebiges Zeichen dann aus der Menge Leerzeichen 0-4 Wort Zeichen
regexp_substr(  'Hauptstraße 32 ab','\\d{1,4}[ ]?\\w{0,4}')     32 ab  -- 1-4 Ziffern ein oder kein Leerzeichen dann aus der Menge Leerzeichen 0-4 Wort Zeichen	
/* Hausnummern extrahieren '*/	

/* Umbennennen mit regulären Auasrücken
########################
*/

Ausdruck zum Einfügen einer Beschriftung, bei der bei allen namen die länger als 15 Zeichen sind, Leerzeichen, Punkt oder Minus um ein #
ergänzt wird, welches als Zeichen für den Zeilenumbruch definiert wurde. Das ursprüngliche Zeichen bleibt erhalten.

Die lässt sich entweder mit einer Replace-Kaskade umsetzen:

replace(replace(replace("name",'.','.#'),' ',' #'),'-','-#')

oder über einen regulären Ausdruck im regexp_replace(

regexp_replace("name",'(-)|( )|(\\.)','\\1\\2\\3#') 

regexp_replace("name",		 -- Das | steht für Alternativen, Zu suchen sind ' ' oder '.' oder  '-'. Der Punkt muss mit \\ maskiert werden, weil 
			'(-)|( )|(\\.)', -- er für beliebigt Zeichen steht.  Die Werte bilden in () Gruppen auf die als Referenz zugegriffen werden kann
			'\\1\\2\\3#') 	-- Mit \\1\\2\\3 werden Suchbegriffe wieder ausgegeben umd anschließend um das # ergänzt

-- Es geht aber auch einfacher:
'([- \\.])'  -- Die drei Begriffe können inkl. Punktmaskierung zwischen [] eingetragen werden durch die weitere () als \\1 referenziert werden
			 regexp_replace("name" ,'([- \\.])','\\1#')  

--Der fertige Ausdruck sieht dann folgendermaßen aus.
if(length( "name" ) >= 15, 
				regexp_replace("name" ,'([- \\.])','\\1#')  
				,"name"
			)


    
/*########################
Doppelte Geometrien
########################
*/
Wenn Sie doppelte Geometrien löschen möchten, gibt es das Werkzeug:

Verarbeitung > Werkzeugkiste:
Vektoren allgemein > Doppelte Geometrien löschen

Sie können doppelte Geometrien über den Ausdruckseditor wählen:
Layer im Inhaltsverzeichnis anklicken
Bearbeiten > Auswählen > Objekte nach Ausdruck wählen
(oder über das Symbol "ε auf gelb" in der Attributtabelle.

Mit dem Ausdruck

	count( $id ,group_by:=geom_to_wkt($geometry)) > 1

wählen Sie alle Objekte deren Geometrien mehrfach forhanden sind.

Wenn Sie

	case when
	count( $id ,group_by:=geom_to_wkt($geometry)) > 1
	then $id <> maximum($id,group_by:=geom_to_wkt($geometry))
	end

eingeben

werden nur die mehrfachen Objekte gewählt. Eines der Objekte mit den
Geometrieduplikaten wird nicht gewählt. Wenn Sie die Auswahl
anschließend löschen, gibt es keine Duplikate mehr. Das funktioniert
auch bei mehr als doppelten Geometrien.

Wenn Sie statt des Ausdruckseditors den Feldrechner öffnen und
mit dem Ausdruck:

	count( $id ,group_by:=geom_to_wkt($geometry))

eine neue Spalte füllen, schreibt QGIS die Anzahl der mit dem jeweiligen
Objekt identischen Geometrien in diese Spalte, also 2 bei Doppelten.

Folgendes macht dieser Ausdruck
count( 			-- zähle
	$id ,		-- die eindeutige Zeilenkennung
	group_by:= 	-- gruppiere nach folgendem Ausdruck:
	       geom_to_wkt($geometry) --Textrepräsentation der Geometrie
	)
> 1	-- Wähle Sämtliche Objekte, die mehr als einmal vorkommen

Eigentlich müsste ($geometry) statt geom_to_wkt($geometry) reichen.
Funktioniert aber nicht.


/*
########################
Beschriftungen
Im Bereich Beschruftungen gibt es besonders viele Anlässe für Ausdrücke
########################
*/
P7
/* Platzierung der Beschriftung */
-- z.B. Unter
Layer > Eigenschaften > Beschriftung > 

Dort: 
if("xc" is not NULL, make_point("xc","yc")
	,	
	case 
		when "platz_typ" = 1 then   pole_of_inaccessibility($geometry,0.1)
		when "platz_typ" = 2 then    point_on_surface( $geometry)
		else centroid($geometry)
	end
	)
	
Es wird geprüft, ob in der Spalte "xc" händisch ein Wert eingetragen worden ist
	

	
/*
########################
Schriftgröße steuern
########################
*/	

/* Anhand der Wurzel der  Flächengrößen */
if("schr_gr"  is NULL,
	case
		when sqrt($area ) /  length( "gen") > 1500 then 1500
		when sqrt($area ) / length( "gen")  < 500 then 500
		else sqrt($area ) / length( "gen") 
	end 
,"schr_gr" 
)


/* Alternative */
scale_linear( 
				sqrt($area ) / length( "gen"),
						minimum(sqrt($area ) / length( "gen")),
						maximum(sqrt($area ) / length( "gen")),
						300,2500)
/* Alternative */



/* Anhand der Verhältnisses der  von Fläche und Umfang */
if("schr_gr"  is NULL,
	case
		when (($area /  $perimeter ) / 2) > 3500 then 3500
		when (($area /  $perimeter ) / 2) < 500 then 500
		else (($area /  $perimeter ) / 2) 
	end
	,
"schr_gr"
)

/* Anhand der Längsten Linie dirch die Boundingbox */
with_variable('ma',
		 max(bounds_height( oriented_bbox( $geometry)), 
			bounds_width(  oriented_bbox( $geometry))
			)
		 / length("gen" )
		,
if("schr_gr"  is NULL,
case
	when @ma > 1200 then 1200
	when @ma < 500 then 500
	else @ma 
end
,"schr_gr" 
)
)

--Schriftdrehungen:
main_angle($geometry) + 90
	
/*########################
Koordinaten BaWue
########################
*/
/* Koordinaten für Bawue extrahieren */

https://geodatenshop.lgl-bw.de/gap/benutzer/gapLogin.aspx

Folgende Form wird gefordert:
Sowohl die einzelnen Nord- und Ostwerte, als auch die einzelnen Punkte müssen durch Komma getrennt werden; die Koordinatenwerte des Anfangspunkts können am Schluss wiederholt werden.Geben Sie die Werte auf ganze Meter an. Beispiel (Dreieck): 
513611, 5411101, 513607, 5411039, 513682, 5411096, 513611, 5411101

/* Koordinaten ausgeben */
replace(
	array_to_string( 
		 array_foreach( 										-- Für jedes einzelne Element des Array etwas tun
			string_to_array( 
				regexp_replace( 								-- Weitere Ersetzung ', ' oder ' ' zu Kommas umwandeln Regex mit oder: |
				trim(											-- Führende Leerzeichen rauslöschen
					regexp_replace( 							-- Alles ausser Ziffern aus dem EKT entfernnen
						geom_to_wkt(  simplify( $geometry,31)),  -- Geometry als WKT Vereinfacht, um wweniger als 150 Punkte zu bekommen
							'[A-Za-z()]','')					-- Alles außer Ziffern aus dem EKT entfernnen
							),
					', | ',',')									-- Weitere Ersetzung ', ' oder ' ' zu Kommas umwandeln Regex mit oder: |
				),
				round(@element)									-- Jedes Element des Array runden
			)
		),
	',',', '
)
/* Koordinaten zählen */

array_length( 									-- Anzahl der Elemente des Array
			string_to_array( 
				regexp_replace( 
				trim(
					regexp_replace( 
						geom_to_wkt(  simplify( $geometry,31)),
							'[A-Za-z()]','')
							),
					', | ',',')
				)
		)
 / 2											--geteil durch 2 wegen Koordinatenpaar

/*########################
P8 Räumliche Abfragen mit Aggregate und overlay
########################
*/


/* Zählung der Windanlagen in den Gemeinden zwei methoden
overlay_intersects() überprüft die Überschneidung von Geometrien des angegebenen Layers ('kraftwerke') mit Geometrien 
des Layers, auf dem die Abrage durchgeführt wird.
Beim ersten Beispiel (expression:= "quelle" = 'wind'=) wird für jede WKA im Polygon eine '1' geschrieben.
Für alle anderen Kraftwerke eine '0'. Befinden sich 3 WKA und 3 andere Kraftwerke im Gebiet, ergibt sich folgendes Array: ['0','1','0','1','0','1',] (Anordnung von 0 und 1 egal)
array_count(...,'1') zählt dann sämtliche Einsen.
Im zweiten Beispiel wird der jeweils gefundene Wert aus der Spalte "quelle" in Array geschrieben, aber nur sich dort der Wert 'wind' (filter:= "quelle" = 'wind') befindet.
Stehen der 3 Windanlagen im Polygon, ergibt es ein Array mit ['wind','wind','wind'] array_length( ['wind','wind','wind']) gibt 3 aus.


*/


array_count( 
 overlay_intersects( 'kraftwerke',
				expression:= "quelle" = 'wind'
				),'1'
				)
				
 array_length( 
	overlay_intersects('kraftwerke' ,
						expression:= "fid",
						filter:=  "quelle" = 'wind'
						)
					)
				
-- Man kann das auch so schreiben, die Angabe der Parameternamen (z.B. expression:=) ist optional verbessert aber die Lesbarkeit,
array_length( overlay_intersects( 'kraftwerke', "quelle", "quelle" = 'wind'))


-- Das Gleiche über aggregate
coalesce(
aggregate( 
		aggregate:=  'count',
		layer:=	     'kraftwerke',
		expression:= "fid",
		filter:=     "quelle" = 'wind' 
					and
					intersects( $geometry, geometry(@parent))
					),0
					)
					
					
/* Leistung der WKA aummieren */

 coalesce(
 array_sum( 
	overlay_intersects('kraftwerke' ,
						expression:= "mw",
						filter:=  "quelle" = 'wind'
						)
					),0
					)

					--oder
coalesce(
aggregate( 
		aggregate:=  'sum',
		layer:=	     'kraftwerke',
		expression:= "mw",
		filter:=     "quelle" = 'wind' 
					and
					intersects( $geometry, geometry(@parent))
					),0
					)
					
/* Leistung der WKA aummieren */
/* In welcher Gemeinde liegen die Windanlagen?*/
 
 -- array_first(  
 overlay_intersects( 'gemeinden',
					expression:= "gen"
					)[0]
					--)

					
aggregate( 'gemeinden',
		aggregate:= 'concatenate_unique',
		expression:= "gen",
		--filter:= "gemeinde" = attribute(@parent,'gen'),
		filter:=  intersects( $geometry, geometry(@parent) ),
		concatenator:= ',\n'
			)

 /*
P9: Filterung der Wertbeziehung
Filterung des Drop-Down-Menüs aus der Liste mit Nutzungen und Nutzungscodes..

Nachdem die Klartext-Nutzung über Wertbeziehung eingetragen worden ist, kann der in die Spalte nutz_txt eingetragene
Wert zur Filteruung der Nutzungscode-Liste verwendet werden: current_value( 'nutz_txt') gibt den in der Spalte nutz_txt 
eingetragenen Wert aus. Über = "Nutzung" wird die Zeile in der Listentabelle herausgefiltert, in der sich der betreffende Klartextwert befindet.
Nur der in dieser Zeile befindliche Nutzungscode kann anschließend im Dropdownmenü für den Nutzungscode ausgewählt werden..
Einzutragen unter Attriibutformular > Bedienelementtyp: Wertbeziehung  > Filterausdruck
 */
 
 current_value( 'nutz_txt') =  "nutzung" 

 /*
Ebenso ist beim Drop-Dopdown-Menü der der Wertbeziehungen eine räumliche Filterung möglich.
Z.B. bei der Zuordnung der fid des Nutzungs-Polygonlayers als fl_id in der Eingabe des Arten-Punktlayers.
Die fid wird im Dropdownmenü über Wertbeziegung eingetragen.  Über eine Filterung wird die Liste der möglichen fid,
auf das Polygon eingeschränkt, in welchem sich der ArtenPunkt befindet.
Der Filterbefehl in menschnlicher Sparache lautet:
Übersschneidung von(Geometry des Flächenlayer, mit Geometrie des eingefügten (aktuellen) Punktobjektes)
Im QGIS:
*/
intersects( $geometry,@current_geometry )
			
			
/*
Liste in einem Feld sortieren
Z.B. die aggregiert Gemeindeliste.
Hier werden  Arrays (Listenfelder) genutzt, die für das Schreiben in die Tabelle jedoch wieder in Textwerte umgewandelt werden müssen
(array_to_string). Vorher werden aus dem Textwert über die Kommata zwischen den Gemeinden Einzelwerte als Array erzeugt (string_to_array)
Mit array_sort() werden Werte alphabetisch sortiert.

Ein komplexer Ausdruck wird von Innen heraus ausgeführt.  Der 1. ausgeführte Ausdruck liegt in der Mitte,
dessen Ergebnis wird vom nächsten äusseren Ausdruck weiterverarbeitet etc.
Das Ganze ist verschachtelt aufgebaut.  (Siehe Nummerierung)
*/

replace(											-- 6. Komma durch Komma und Zeilenumbruch ersetzen
	substr(											-- 5. störendes komma vorne löschen
		array_to_string(  							-- 4. Aus Listenfeld (Array) wieder Zurück zum text (eine Zeichenkett)
				array_sort( 						-- 3. Einzelwerte sortiere
				string_to_array( 					-- 2. aus Text Einzelwerte in Liste (Array) erzeugt
					replace("liste", '\n' ,'') 		-- 1. Zeilen umbruch entfernen
					)								-- 2. aus text Einzelwerte (Arrays)erzeugt
				)									-- 3. Einzelwerte sortier
		)											-- 4. Ist Wieder text
	,2)		                                  		-- 5. Platz 1 raus, Komma gelöscht
, ',',',\n')				                		-- 6. Komma durch Komma und Zeilenumbruch ersetzt





/* 
###########################
Eine gebogene Linie für eine Punktbeschriftung ünber den geometriegenrator 
########################################
*/


P10
	-- Kreisboegen generieren im Geometriegenrator
	geom_to_wkt(
		   translate( -- Funktion verschieben des Bogens
		            difference( --Funktion Ausstanzen der Grundlinie  des Kreisabschnitts
		                      boundary(--Funktion Kriesausschnitpolygon in Linien umwandeln
					       difference( --Funktion ausstanzen des Kreisabschnitts durch das Rechteck
		                                          (buffer( $geometry,1200,45)), -- Funktion: erstellen des Kreispuffers, erster Wert ist der Kreisbogenradius, je Höher der erste Wert, desto länger der Bogen -
                                                                                       -- Wenn der Radius höher gesetzt wird, Wird die Kurve flacher

                                                           --das Rechteck zum ausstanzen des Kreisausschnitts wird als Linie erzeugt	                 --je größer die Werte desto flacher der Bogen
		                                          (make_polygon(  geom_from_wkt( 'Linestring('      || ($x +1600) ||' '||   ($y +800) || -- Rechte oberer Ecke: X muss größer als Radius sein, y kleiner: 
	   
	    										              ', '  || ($x +1600) ||' '||   ($y -1600) ||  --Rechte untere Ecke, X und y müssen größer als Radius sein
	   
	    										              ', '  || ($x -1600) ||' '||   ($y -1600) ||  -- Werte wie Zeile 2, nur beides jeweils minus
	   
	    										              ', '  || ($x -1600) ||' '||   ($y +800) ||  -- Linke obere Ecke:  Werte gleich wie Zeile 1 (außer das Minuszeichen)
	   
	  										              ', '  || ($x +1600) ||' '||  ($y + 800) || ')' -- Abschlusspunkt,Werte gleich wie zeile 1
	   						              ) -- Rechteckgeometrie als geschlossener Linienzug erzeugt
		                                         )  --Umwandlung des Linienrechtecks in eine  Polygon 
		                                         ) -- Ende Funktion Ausstanzen des Kreisabschnitts
		                              ) -- Ende Funktion in Linen umwandeln
		                    ),  -- erzeugte Linien des Kreisabschnitts werden dem ausstanzen der unteren Grundlinie übergeben
	
			 geom_from_wkt('Linestring('  || ($x +1600) ||' '||   ($y +800) || ', '  ||  ($x - 1600) ||' '||   ($y +800)  || ')') -- Geometrie der Schnittlinie, Zahlen müssen gleich der Werte des oberen Rechteckrandes sein
		                    ) -- Ende Funktion Ausstanzen der Grundlinie  des Kreisabschnitts
		 ,0,-150) -- Werte für die Funktion: Verschieben des Bogens vom Punkt, je kleiner der Minuswert, desto weiter entfernt ist der Bogen vom Punkt
	)


	
		-- Kreisbögen generieren im Geometriegenrator
		translate( 
				difference( 
					boundary(
						  difference(
									(buffer( $geometry,1200,45)),
											make_polygon(  
														geom_from_wkt( 'Linestring('      || ($x +1600) ||' '||   ($y +800) ||  
	   
																					', '  || ($x +1600) ||' '||   ($y -1600) || 
	   
																					', '  || ($x -1600) ||' '||   ($y -1600) ||  
	   
																					', '  || ($x -1600) ||' '||   ($y +800) ||  
	   
																					', '  || ($x +1600) ||' '||  ($y + 800) || ')' 
																	) 
													)  
								) 
		                    ), 
			 geom_from_wkt('Linestring('  || ($x +1600) ||' '||   ($y +800) || ', '  ||  ($x - 1600) ||' '||   ($y +800)  || ')')
		                    )
		 ,0,-700) 




